%ext ck1

########

# TH WASN"T HERE
# THEREFORE COMMENTS

# INTRO SEQUENCE

#%patch $A224 $90 $90 $90 #No presentation
#%patch $A248 $90 $90 $90 #No id software bitmap

#Remove bitmaps
#%patch $A1FD $90 $90 $90 #An
#%patch $A20F $90 $90 $90 #Still Apogee
#%patch $A1E3 $90 $90 $90 #Rising Apogee
#%patch $A224 $90 $90 $90 #Presentation
%patch $A236 $90 $90 $90 #Of an
%patch $A248 $90 $90 $90 #Id software
%patch $A25A $90 $90 $90 #Production

#Bitmaps used in sequence:
#%patch $6FA1 $0E #One moment
#%patch $A1EF $08 #An
#%patch $A1D8 $0A #Apogee rising
#%patch $A204 $0A #Apogee still
#%patch $A216 $09 #Presentation
#%patch $A22B $0F #Of an
#%patch $A23D $11 #ID software
#%patch $A24F $10 #Production

########

# Change the controls to: Space, shoot; Enter, status. 
%patch $1251  $48 
%patch $7FA3  $48 
%patch $3B23  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3C4E  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DB9  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3DCC  $90 $90 
%patch $3E6D  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $3FFC  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 
%patch $40AA  $90 $90 $90 $90 $90 $90 $90 $80 $3E $65 $50 $00 

# BIG SPRITE SUPPORT WOOO
%patch $BB63 $90 $90

%patchfile $BC3B sprb.bin

%patch $BBA4 $E8 $94W $90 $90

%patch $BBCE $E8 $6AW $90 $90

%patch $BBF8 $E8 $40W $90 $90
%patch $BC22 $E8 $16W $90 $90

########

#Change the teleporter locations
#Location 1 13,39
%patch $158DF $D0 $00 
%patch $158E3 $70 $02

#Location 2 13,26
%patch $158E9 $D0 $00
%patch $158ED $A0 $01

#Location 3 17,43
%patch $158F3 $E0 $01
%patch $158F7 $70 $02

#######

#Change the animating switch
%patch $36DB $1C $01 #This tile when flipped becomes...
%patch $36E0 $1D $01 #This tile and...
%patch $36FC $1D $01 #This tile when flipped becomes...
%patch $3716 $1C $01 #This tile.

#sprites below INGAME type #9 operate off screen 
%patch $3347 $90 $90 $90  $90 $90 $90 $EB $0B 

####
# IN-LEVEL SCORE COUNTER
####

#Number of keens at start (0)
%patch $9002 $00 $00

#number lives counts deaths
%patch $8041 $FF $06 $C6 $AA

#Display death count in extra score
%patch $0FA7 $A1 $C6 $AA $33 $D2 $52 $50 $90
                 $90 $90 $90 $90 $90 $90 $90 $90

#keen death A, reset score
%patch $427D $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90

#keen death B, reset score
%patch $42BB $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90

#level load, save temp score
%patch $4BAE $66 $A1 $CA $AA $66 $A3 $00 $AF $66 $33 $C0 $66 $A3 $35 $51 $66 $A3 $3E $56 $A3 $14 $5B $90 

###

# This is the color palette: 16 entries of r, g, b (each 0-63) 
%patch $21850 
       00 00 00 #black 
       00 00 42 #blue 
       00 40 00 #green 
       00 42 42 #cyan 
       42 00 00 #red 
       42 00 42 #magenta 
       42 21 00 #brown 
       24 24 24 #bright gray 
       06 06 06 #gray 
       21 21 63 #bright blue 
       20 63 20 #bright green 
       21 63 63 #bright cyan 
       63 21 21 #bright red 
       63 21 63 #pink 
       63 63 21 #yellow 
       63 63 63 #white
# lights out palette 
       00 00 00 # black 
       00 00 42 # blue 
       00 21 00 # green 
       00 21 42 # cyan 
       21 00 00 # red 
       21 00 42 # magenta 
       21 10 00 # brown 
       21 21 42 # bright gray 
       10 10 21 # gray 
       10 10 63 # bright blue 
       10 42 21 # bright green 
       10 42 63 # bright cyan 
       42 10 21 # bright red 
       42 10 63 # pink 
       42 42 21 # yellow 
       63 63 63 # white 

#---------------------------------------------------------------------------- 

# set EGA color register values for VGA pass-thru 
%patch $1558B   $00 $01 $02 $03 $04 $05 $06 $07 
                $08 $09 $0A $0B $0C $0D $0E $0F $03 

# Set the palette when we go into graphics mode 
%patch $6E46 $E8 $60 $FE $90 $90 

# Code to set graphics mode and set the palette 
%patch $6CA9 $B8 $0D $00 $CD $10 $B8 $13 $10 $BB $00 $01 $CD $10 $B8 $02 $10 
             $1E $07 $BA $3B $25 $CD $10 $B8 $12 $10 $B9 $20 $00 $31 $DB $BA 
             $00 $E8 $CD $10 $C3 

#support functions 
%patch $5B3D $BA $DA $03 $EC $A8 $08 $75 $FB $EC $A8 $08 $74 $FB $C3 $55 $89 
             $E5 $E8 $EC $FF $BA $DA $03 $EC $BA $C0 $03 $EC $50 $B0 $14 $EE 
             $8B $46 $04 $EE $58 $EE $89 $EC $5D $C3 $55 $89 $E5 $83 $EC $08 
             $31 $C0 $31 $DB $89 $46 $F8 $8A $87 $00 $E8 $2A $46 $04 $73 $02 
             $31 $C0 $89 $46 $FA $43 $8A $87 $00 $E8 $2A $46 $04 $73 $02 $31 
             $C0 $89 $46 $FC $43 $8A $87 $00 $E8 $2A $46 $04 $73 $02 $31 $C0 
             $89 $46 $FE $43 $E8 $B7 $10 $FF $46 $F8 $83 $FB $60 $75 $C8 $89 
             $EC $5D $C3 
%patch $6C5B $55 $89 $E5 $BA $C8 $03 $8B $46 $04 $EE $BA $C9 $03 $8B $46 $06 
             $EE $8B $46 $08 $EE $8B $46 $0A $EE $89 $EC $5D $C3 

#VGA palette fading 
#fade in 
%patch $6C49 $B9 $20 $00 $E8 $EE $EE $89 $C8 $48 $50 $E8 $11 $EF $44 $44 $E2 
             $F2 $C3 
#fade out      
%patch $6C8D $B9 $20 $00 $E8 $AA $EE $B8 $40 $00 $29 $C8 $50 $E8 $CB $EE 
             $44 $44 $E2 $F0 $31 $C0 $50 $E8 $A5 $EE $44 $44 $C3 

#VGA lights 
# delay value-----------------------------v 
%patch $3592 $C7 $06 $1E $82 $01 $00 $B8 $01 $00 $50 $E8 $43 $8B $44 $44 $31 
             $C0 $50 $E8 $A4 $25 $44 $44 $C3 # on 
# delay value-----------------------------v 
%patch $35B2 $C7 $06 $1E $82 $00 $00 $B8 $01 $00 $50 $E8 $23 $8B $44 $44 $B8 
             $01 $00 $50 $E8 $83 $25 $44 $44 $C3 # off 

####

# Pogo at start
%patch $900E  $01 $00 

# TITLE SCREEN
# Locations: (v in pixels, h in 8x pixels)
%patch $97B2 $00 $00 #Title V
%patch $97B6 $08 $00 #Title H
%patch $97C4 $B6 $00 #F1 V
%patch $97C8 $04 $00 #F1 H

# ENDING CONDITIONS
%patch $8022 $C4 $AA $00 $74 #Joystick -> level 16
%patch $8029 $C4 $AA $00 $74 #Battery -> level 16
%patch $8030 $C4 $AA $00 $74 #Vacum -> level 16
%patch $8037 $C4 $AA $00 $74 #Whiskey -> level 16

### ENDING STUFF

# MAP SCENE

# Return to BWB
# Camera coordinates (1000h = 1 pixel)
#%patch $81D6 $3000W # x hi $3000W
#%patch $81DA $0000W # x lo $0000W
#%patch $81E3 $3000W # y hi $3000W
#%patch $81E8 $0200W # y lo $0200W

# Sprite coordinates
#%patch $81F5 $0002W # x hi $0002W
#%patch $81F8 $7000W # x lo $7000W
# x hi = 0 ($81FC $33 $C0 xor ax, ax)
#%patch $81FF $D000W # x lo $D000W

# Return to BWB
# Camera coordinates (1000h = 1 pixel)
%patch $81D6 $4000W # x lo $3000W
%patch $81DC $0000W # x hi $0000W
%patch $81E2 $6000W # y lo $3000W
%patch $81E8 $0000W # y hi $0002W

# Sprite coordinates
%patch $81F5 $0000W # y hi $0002W
%patch $81F8 $7000W # y lo $7000W
# x hi = 0 ($81FC $33 $C0 xor ax, ax)
%patch $81FF $B000W # x lo $D000W

# TO BE CONTINUED...
%patch $15E72 "Pieraty On!" $0A $00
%PATCH $15CBD "Let's see if any of these buttons" $0A $00
%patch $15CE0 "will fix the problem." $0A $00

#%patch $81A3 $02     #No flight to earth or mars map sequence

#First house textbox:
%patch $8546 $18 $00 #Bottom
%patch $854A $2B $00 #Right side
%patch $854E $15 $00 #Top
%patch $8552 $04 $00 #Left
%patch $857A $78 $00 #Time visible
%patch $855F $6D $2C #First Line of text read from:
%patch $8568 $90 $2C #Second Line of text read from:
#%patch $8571 $99 $2C #Third Line of text read from:

# Remove second and third lines
#%patch $8565 $90 $90 $90 $90 $90 $90 $90 $90 $90
%patch $856E $90 $90 $90 $90 $90 $90 $90 $90 $90

#Second textbox
%patch $85D5 $18 $00 #Bottom
%patch $85D9 $2B $00 #Right
%patch $85DD $15 $00 #Top
%patch $85E1 $04 $00 #Left
%patch $8606 $B4 $00 #Time visible
%patch $85EB $A7 $2C #First Line of text read from:
%patch $85F4 $C7 $2C #Second Line of text read from:
#%patch $85FD $D5 $2C #Third Line of text read from:

# Remove third line
%patch $85FA $90 $90 $90 $90 $90 $90 $90 $90 $90 

%patch $15CF7 "Nope, that didn't seem to make" $0A $00
%patch $15D17 "any difference..." $0A $00

#Stop 3rd textbox appearing
%patch $8635 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90

#Fourth textbox
%patch $867B $18 $00 #Bottom
%patch $867F $2B $00 #Right
%patch $8683 $15 $00 #Top
%patch $8687 $04 $00 #Left
%patch $86A3 $B4 $00 #Time visible
%patch $8691 $DA $2C #First Line of text read from:
%patch $869A $FD $2C #Second Line of text read from:

%patch $15D2A "Maybe if I try turning it off and" $0A $00
%patch $15D4D "on again..." $0A $00

#Stop 5th textbox appearing
%patch $86AF $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90

#Stop 6th textbox appearing
%patch $86EC $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90

#Stop 7th textbox appearing
%patch $8714 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
             $90 $90 $90 $90 $90 $90 $90

#Eighth textbox
%patch $877C $18 $00 #Bottom
%patch $8780 $2B $00 #Right
%patch $8784 $15 $00 #Top
%patch $8788 $04 $00 #Left
%patch $87C8 $2C $01 #Time visible
%patch $879B $0A $2D #First Line of text read from:
#%patch $87A4 $CE $2D #Second Line of text read from:
#%patch $87AD $E7 $2D #Third Line of text read from:
#%patch $87B6 $FC $2D #Fourth Line of text read from:
#%patch $87BF $13 $2E #Fifth Line of text read from:

%patch $15D5A "Bingo! This time for sure." $0A $00

#Remove the other four lines
%patch $87A1 $90 $90 $90 $90 $90 $90 $90 $90 $90 
%patch $87AA $90 $90 $90 $90 $90 $90 $90 $90 $90 
%patch $87B3 $90 $90 $90 $90 $90 $90 $90 $90 $90 
%patch $87BC $90 $90 $90 $90 $90 $90 $90 $90 $90 

###

# Return to BWB 
%patch $15C24 "Keen tackles his out of control" $0A $00
%patch $15C49 "club house and leaps inside," $0A $00
%patch $15C6C "wiring up a spare joystick to the" $0A $00
%patch $15C91 "hydraulics system." $0A $00

%patch $81F1  70     #Sprite shown (clubhouse)

#FLIGHT TO MOTHERSHIP (PARTY DAENCN)

#move win array 2 lower on stack to make room
%patch $81A7 $F800W

#new offset of win array 2
#Change Address from C000 to D000W
%patch $81AC $D000W #default address 296A
%patch $81B0 $0600W #length of array

#patch win array at $13050 + address
#values here....

#win2_x on stack
%patch $882E $F800W
%patch $8877 $F800W

#win2y on stack
%patch $8847 $F802W
%patch $8886 $F802W

# movement data for the clubhouse sprite in the final scene
%patchfile $20050 dance.bin

%patch $8819 $00 $0F #How long ship stays on Earth

# Skip ? and ! sequence, straight to the backyard
%patch $83E0 $E8 $34 $01

########

%patch $834E $0W   #X scroll lolololol
%patch $8354 $00   #X scroll hi
%patch $8359 $160W #Y scroll lo
%patch $835F $00   #Y scroll hi
%patch $8363 $0W   #X ship lo
%patch $8368 $00   #X ship hi
%patch $836c $160W #Y ship lo
%patch $8371 $00   #Y ship hi

%patch $82D0 70 #Sprite used for rocket going up from earth
%patch $8328 70 #Sprite used for part of rocket going to earth [screen imobile]
%patch $8376 70 #Sprite used for most of rocket going to earth [screens moves]
%patch $83B5 70 #Sprite used for rocket going down to earth
%patch $83E4 70 #Sprite used for rocket when ? appears
%patch $83FA 118W #? sprite
%patch $843B 70 #Sprite used for rocket going to vortiship
%patch $8461 70 #Sprite used for rocket when ! appears
%patch $8477 117W #! sprite
%patch $84DF 116W #Rocket landing on earth sprite
%patch $87FD 116W #Rocket sprite shown on Earth
%patch $8857 116W #Sprite for rocket going to vortiship
%patch $8892 116W #Sprite for rocket LANDED on vortiship

# Screen doesn't scroll horizontally on flight to earth 
%patch $834A $90 $90 $90 $90 $90 $90 
%patch $8350 $90 $90 $90 $90 $90 

# Flight to mothership
%patch $87D4  82     #Level (Coords are last location of rocket sprite)

######

# SPRITE SWAPS

# Tree Purple (Keen home)
%patch $858F $11 $00 #Purple tree
%patch $8596 $0B $00 #Window x location

# Tree Green (Keen sleep)
%patch $85B2 $0F $00 #Green tree
%patch $85B9 $0B $00 #Dark Window x location

# Yorp Blue (parents in)
%patch $861B $0C $00 #Blue yorp
%patch $8622 $0B $00 #Window x location

# Yorp Green (parents out)
%patch $8748 $0D $00 #Green yorp
%patch $874F $0B $00 #Window x location

# Clubhouse Normal (no sleep for Keen!)
%patch $876B $10 $00 #Sprite used for light window
%patch $8772 $1A $00 #Window x location

#Set x and y location of final window sprite (clubhouse)
#%patch $876E $66 $6A $001C0000EL $90 

#patch $87FD $74 $00 #Rocket sprite shown on Earth
%patch $8819 $1E $00 #How long ship stays on Earth
#patch $8857 $74 $00 #Sprite for rocket going to vortiship
#patch $8892 $73 $00 #Sprite for rocket LANDED on vortiship

##################

#Pogo acts normally in God Mode
%patch $3F4E $EB

#Touching a Vorticon in level 16 Ends the Game
%patch $46A2 $0AF2W #jump to new code on vorticontact
%patch $AF2  $C7 $06 $20 $82 $00 $00 $C7 $06 $60 $6C $01 $00 #tell game to exit level
             $B8 10W #play SOUND 10
             $E9 $3B8FW #go back

%patchfile 0x130F8 bw.tli

### VORTICON ANIMATIONS

%patch $183E 70  #Vorticon start [Not often seen]

%patch $1C1D 70  #Walking right
%patch $1C25 70  #Walking left -1
%patch $1C2F 0   #Frames used for both
%patch $1C2B 0   #Animation speed

%patch $1D29 70  #Looking around [Yes it uses jump sprites!]
%patch $1D26 0   #Frames used -1
%patch $1D22 0   #Animation speed

%patch $1C1D 70  #Jumping right
%patch $1C25 70  #Jumping left
%patch $1C5A $0E $1C
%patch $1CF2 $0E $1C

%patch $1DA3 70  #Shot
%patch $1D9E 0   #Frames used
%patch $2359 70  #When chain is shot
%patch $2354 0   #Frames used

###

### TANK BOT ANIMATIONS

%patch $1772 98 #Start [Not often seen]

%patch $1EB8 99 #Walking left
%patch $1EC0 98  #Walking right
%patch $1ECC 0   #Frames used for both

%patch $1FA7 99 #Turning
%patch $1FA4 0   #Frames used
%patch $1FA0 0   #Animation speed

###

#About ID text
%patch $15F80 "This superb contribution to the    " $0A
%patch $15FA8 "Commander Keen community is brought" $0A
%patch $15FD0 "to you by Commander Spleen, a.k.a. " $0A
%patch $15FF8 "Jimage.                            " $0A $0A
%patch $16020 "Inevitable cereal goes to the many " $0A
%patch $16048 "Keeners who have made ridiculously " $0A
%patch $16070 "awesome patches and utilities that " $0A
%patch $16098 "make mods such as this possible    " $0A $0A
%patch $160C0 "Don't worry, I'm straight back to  " $0A
%patch $160E8 "work on other well overdue projects" $0A
%patch $16110 "after this surprise release. Party!" $0A

%patch $8392 $00 $02
%patch $8173 $01 $00 #Text writing speed (Larger = slower)

#Tank Bot shot height

%patch $4900     $20
%patch $4902 $00 $00

#Big versitile status window patch:
# Patch in the long-integer drawing function 
%patch $11B4                   $55 $89 $E5 $B8 $0A $00 $50 $B8 $90 $82 $50 $FF 
               $76 $06 $FF $76 $04 $E8 $03 $C2 $83 $C4 $08 $B8 $90 $82 $50 $E8 
               $A5 $C5 $44 $44 $8B $56 $08 $29 $C2 $89 $16 $82 $82 $8B $46 $0A 
               $A3 $F8 $82 $B8 $90 $82 $50 $E8 $E8 $50 $44 $44 $89 $EC $5D $C3 

# Patch in the name of the status dialog text file, you'll need to create a file with this name and put your status
# text in it or Keen will crash. An example status file can be found in this directory.
%patch $13084  "STATUS.CK1" $00 

# Patch in the code to draw the status text (coordinates are measure in characters--8 pixel blocks) 
%patch $0E6A                                           $B8 $00 $3D $BA $34 $00   # Show status window (0E6A) 
               $CD $21 $89 $C3 $BF $27 $00 $C6 $06 $9A $82 $00 $B9 $0A $00 $BA 
               $90 $82 $B4 $3F $CD $21 $53 $B8 $90 $82 $50 $E8 $2E $97 $44 $44 
               $5B $4F $75 $E8 $B4 $3E $CD $21 
                                               $8B $46 $FE $05 $01 $00 $50 $89   # Show score (0E98) 
               $F0 $05 $0A $00 $50 $FF $36 $CC $AA $FF $36 $CA $AA $E8 $04 $03 
               $83 $C4 $08 
                           $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90   # Show extra Keen score (0EB3) 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 
                                       $90 $90 $90 $90 $90 $90 $90 $90 $90 $90   # Show Keens (0ED6) 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 
%patch $0F07                               $90 $90 $90 $90 $90 $90 $90 $90 $90   # Draw the joystick 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
                                                                           $90   # Draw the battery 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 
                                           $90 $90 $90 $90 $90 $90 $90 $90 $90   # Draw the vacuum 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
                                                                           $90   # Draw the whiskey 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 
%patch $0FA7                               $B8 $2E $02 $83 $3E $9E $AA $00 $74   # Keycard A 
               $03 $B8 $A8 $01 $50 $8B $46 $FE $05 $07 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $6D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard B 
               $2E $02 $83 $3E $A0 $AA $00 $74 $03 $B8 $A9 $01 $50 $8B $46 $FE 
               $05 $07 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $45 $A9 $83 $C4 $06 
                                           $B8 $2E $02 $83 $3E $A2 $AA $00 $74   # Keycard C 
               $03 $B8 $AA $01 $50 $8B $46 $FE $05 $09 $00 $B1 $03 $D3 $E0 $05 
               $04 $00 $50 $89 $F0 $05 $13 $00 $50 $E8 $1D $A9 $83 $C4 $06 
                                                                           $B8   # Keycard D 
               $2E $02 $83 $3E $A4 $AA $00 $74 $03 $B8 $AB $01 $50 $8B $46 $FE 
               $05 $09 $00 $B1 $03 $D3 $E0 $05 $04 $00 $50 $89 $F0 $05 $17 $00 
               $50 $E8 $F5 $A8 $83 $C4 $06 
%patch $1047                               $90 $90 $90 $90 $90 $90 $90 $90 $90   # Pogo stick 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90
                                                                           $90   # Draw ammo 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 
                                                   $90 $90 $90 $90 $90 $90 $90   # Draw raygun (replace first two bytes 
               $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90 $90   # with $EB $1C if you don't want to 
               $90 $90 $90 $90 $90 $90 $90                                       # draw the raygun on the status screen) 

                                           $E8 $90 $4B $31 $C0 $50 $E8 $1E $AD   # Wait for a key, then return 
               $44 $44 $E8 $81 $A6 $E8 $D1 $F1 $E8 $CE $F1 $E8 $7C $4B $8B $46 
               $FC $8B $56 $FA $89 $16 $35 $51 $A3 $37 $51 $5F $5E $89 $EC $5D 
               $C3 

#Locations and tiles used in the patch
%patch $0E53 $0D $00 #Window height
%patch $0E57 $1C $00 #Window width
%patch $0E9C $01 $00 #Score Y position
%patch $0EA2 $0B $00 #Score X position 

%patch $0FA8 $0B $00 #Tile for no  Keycard A
%patch $0FB2 $A8 $01 #Tile for got  Keycard A
%patch $0FB9 $03 $00 #Y position of  Keycard A
%patch $0FC0 $00 $00 # Keycard A Y offset (pixels)
%patch $0FC6 $01 $00 #X position of  Keycard A

%patch $0FD0 $0B $00 #Tile for no  Keycard B
%patch $0FDA $A9 $01 #Tile for got  Keycard B
%patch $0FE1 $03 $00 #Y position of  Keycard B
%patch $0FE8 $00 $00 # Keycard B Y offset (pixels)
%patch $0FEE $04 $00 #X position of  Keycard B

%patch $0FF8 $04 $00 #Tile for no  Keycard C
%patch $1002 $AA $01 #Tile for got  Keycard C
%patch $1009 $03 $00 #Y position of  Keycard C
%patch $1010 $00 $00 # Keycard C Y offset (pixels)
%patch $1016 $07 $00 #X position of  Keycard C

%patch $1020 $0B $00 #Tile for no  Keycard D
%patch $102A $AB $01 #Tile for got  Keycard D
%patch $1031 $03 $00 #Y position of  Keycard D
%patch $1038 $00 $00 # Keycard D Y offset (pixels)
%patch $103E $0A $00 #X position of  Keycard D

# Height
%patch $E53 $0006W
# Width
%patch $E57 $000DW

###

#Stop the doors bouncing Keen:
%patch $43A4  $E9 $D1 $01
%patch $2F31  $E8 $9D $E1 $90 $90
%patch $2FE6  $E8 $0B $E1 $90 $90
%patch $10D1  $81 $3E $54 $82 $C4 $45 $75 $15 
              $8B $87 $6E $05 $48 $48 $3D $04 
              $00 $73 $0A $89 $C3 $D1 $E3 $83 
              $BF $9E $AA $01 $C3 $83 $BF $86 
              $18 $00 $C3 $81 $3E $54 $82 $C4 
              $45 $75 $15 $8B $87 $6E $05 $48 
              $48 $3D $04 $00 $73 $0A $89 $C3 
              $D1 $E3 $83 $BF $9E $AA $01 $C3 
              $83 $BF $FA $0E $00 $C3 

#Changing pointitem scores:
#These use the default values.
%patch $15078 $01 $00 #100
%patch $1507A $02 $00 #200
%patch $15076 $05 $00 #500
%patch $1507C $10 $00 #1000
%patch $1507E $20 $00 #5000

#-----------------------------------------------------
# HIGH SCORE STUFF
# Don't show the four items [Whether they're got or not]
%patch $9928 $90 #Joystick
%patch $995B $90 #Battery
%patch $998E $90 #Vacum cleaner
%patch $99C1 $90 #Whiskey

# Don't show PARTS label
%patch $98B2 $90 #Parts

#-----------------------------------------------------

#Make Keen act as if he has no shots.
%patch 0x3E30 $EB

#No Keen's Left window
%patch $8F2D $EB $52

#-----------------------------------------------------

#Ordering Info text; Offset in three sections:
%patch $1632C $0A $00
%patch $16346 "  HAPPY 20TH BIRTHDAY" $0A $00
%patch $16361 "    COMMANDER KEEN!" $0A $00
%patch $16379 $0A $00
%patch $16392 $0A $00
%patch $163AD $0A $00
%patch $163C8 $0A $00
%patch $163E3 $0A $00
%patch $1640B $0A $00
%patch $16432 $0A $00
%patch $16459 $0A $00
%patch $1647E $0A $00

%patch $1649E $0A $00
%patch $164C6 $0A $00
%patch $164EE $0A $00
%patch $16516 $0A $00


%patch $16542 $0A $00
%patch $16570 $0A $00

%patch $15F2F "   Mosh Pit     " $0A $00
%patch $15F4F "   Shiny Things" $0A $0A $00 #moves down two lines]
%patch $15F0F "   Waht?      " $0A $00

#Where items are on the highscore table

%patch $99EE $22 #Scores
%patch $9A03 $0D $00 #Names

#Positions of sprites:
%patch $9879 $07     #High scores v
%patch $987D $0F $00 #High scores h
%patch $988B $2C     #name v
%patch $988F $0D $00 #Name h
%patch $989D $2C     #Score v
%patch $98A1 $1C $00 #Score h

######

#Keen 4 like flags in keen 1
#To make a flag marker for level n, you need to put a sprite on the 
#map with number 100 + n; for example, to make a flag marker for 
#level 3, I'd put a sprite number 103 on the map. Be aware that 
#these should only be placed on an area where Keen cannot walk, or 
#they'll act like teleporters if he walks over them and presses Alt. 
#Do not use this patch with the "change Done tiles" patch.
%patch $7C07  $83 $EC $20 
%patch $7D13              $31 $F6 $C4 $3E $4C $6C $8B $16 $08 $6C $A1 $58 $6C 
%patch $7D20  $F7 $E2 $89 $C1 $09 $C9 $75 $03 $E9 $DA $00 $26 $8B $05 $C7 $46 
%patch $7D30  $E0 $00 $00 $A9 $00 $80 $74 $05 $C7 $46 $E0 $01 $00 $25 $FF $7F 
%patch $7D40  $75 $03 $E9 $B9 $00 $89 $46 $FC $3D $10 $00 $7C $03 $E9 $85 $00 
%patch $7D50  $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $75 $03 $E9 $A0 $00 $26 $C7 
%patch $7D60  $05 $00 $00 $83 $7E $E0 $00 $74 $03 $E9 $92 $00 $89 $FB $43 $43 
%patch $7D70  $26 $8B $07 $25 $FF $7F $3B $46 $FC $75 $47 $26 $C7 $07 $00 $00 
%patch $7D80  $03 $1E $08 $6C $03 $1E $08 $6C $26 $C7 $07 $00 $00 $4B $4B $26 
%patch $7D90  $C7 $07 $00 $00 $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 
%patch $7DA0  $C7 $07 $4E $00 $43 $43 $26 $C7 $07 $4F $00 $03 $1E $08 $6C $03 
%patch $7DB0  $1E $08 $6C $26 $C7 $07 $51 $00 $4B $4B $26 $C7 $07 $50 $00 $07 
%patch $7DC0  $EB $3C $06 $C4 $1E $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07 
%patch $7DD0  $4D $00 $07 $EB $29 $3D $65 $00 $7C $24 $3D $74 $00 $7F $1F $2D 
%patch $7DE0  $64 $00 $89 $C3 $D1 $E3 $83 $BF $A4 $AA $00 $74 $11 $06 $C4 $1E 
%patch $7DF0  $48 $6C $89 $F0 $D1 $E0 $01 $C3 $26 $C7 $07 $CD $00 $07 $49 $47 
%patch $7E00  $47 $46 $E9 $1F $FF $EB $4A 

#The Done tiles used WITH the flag markers
%patch $7DA2 $4D $00 #Small done marker
%patch $7DAA $4D $00 #Large done marker 1
%patch $7DB6 $4D $00 #Large done marker 2
%patch $7DBD $4D $00 #Large done marker 3
%patch $7DD0 $4D $00 #Large done marker 4
%patch $7DFB $CD $00 #The tile to be used AS a flag marker

%patch $3E58 25 #Keen no ammo gunclick

#Exit tiles don't change when Keen exits
%patch $417E $90 #Top blank tile doesn't appear
%patch $41A7 $90 #Bottom blank tile doesn't appear

# IN-LEVEL SCORE

#keen death A, reset score 
%patch $427D $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90 

#keen death B, reset score 
%patch $42BB $66 $81 $06 $E2 $6E $00 $08 $00 $00 $66 $A1 $00 $AF $66 $A3 $CA $AA $90 $90 

#level load, save temp score 
%patch $4BAE $66 $A1 $CA $AA $66 $A3 $00 $AF $66 $33 $C0 $66 $A3 $35 $51 $66 $A3 $3E $56 $A3 $14 $5B $90 

%end
